/*

        pd̂߂̓dEdv

        Copyrights 2009-2010, Yoshi Hiroshi
*/

#include <avr/io.h>
#include <util/delay.h>
#include "powerSupply.h"
#include "lcd.h"

// ADC`l
volatile unsigned char adcChannelIndex;

// ^C}[JE^
volatile unsigned int timerCounter;

// f[^Wpz
volatile double voltageTotal; // volt
volatile double amperesTotal; // ampere
volatile unsigned char ampereRange;

// ϒlvZp[N
volatile double voltageAvrage;
volatile double amperesAvrage;

// \p[LÖ
char stringWork[9];
int decimalWork[4];


// dW̔re[u
unsigned int rangeBound[] = 
{
((1024L * 220L) / (2000L + 220L)) / 2,                                              // 2: 100uA
(((1024L * 220L) / (2000L + 220L)) + ((1024L * 440L) / (2000L + 440L))) / 2,        // 3: 1mA
(((1024L * 440L) / (2000L + 440L)) + ((1024L * 660L) / (2000L + 660L))) / 2,        // 4: 300mA
(((1024L * 660L) / (2000L + 660L)) + ((1024L * 880L) / (2000L + 880L))) / 2,        // 5: 1A
(((1024L * 660L) / (2000L + 660L)) + ((1024L * 880L) / (2000L + 880L)) * 2) / 2     // 6: 3A
};

unsigned char GetAdcValue(unsigned int index, unsigned char channel)
{
    unsigned long newValue = ADC;
    double valWork = 0.0;
    switch(channel)
    {
    case ADC_CHANNEL_VOLT:
        valWork = newValue * VOLTAGE_CONV_FACTOR_1 / 1024.0;
        voltageTotal += valWork;
        channel = ADC_CHANNEL_RANGE;
        break;
    case ADC_CHANNEL_RANGE:
        if(newValue < rangeBound[0]) {
            ampereRange = AMPERE_RANGE_10uA;
        } else if(newValue < rangeBound[1]) {
            ampereRange = AMPERE_RANGE_100uA;
        } else if(newValue < rangeBound[2]) {
            ampereRange = AMPERE_RANGE_1mA;
        } else if(newValue < rangeBound[3]) {
            ampereRange = AMPERE_RANGE_300mA;
        } else if(newValue < rangeBound[4]) {
            ampereRange = AMPERE_RANGE_1A;
        } else {
            ampereRange = AMPERE_RANGE_3A;
        }
        channel = ADC_CHANNEL_CURR;
        break;
    case ADC_CHANNEL_CURR:
        switch(ampereRange)
        {
        case AMPERE_RANGE_10uA:
            valWork = (double)newValue * AMPERE_CONV_FACTOR_1 / 1024.0;
            break;
        case AMPERE_RANGE_100uA:
            valWork = (double)newValue * AMPERE_CONV_FACTOR_2 / 1024.0;
            break;
        case AMPERE_RANGE_1mA:
            valWork = (double)newValue * AMPERE_CONV_FACTOR_3 / 1024.0;
            break;
        case AMPERE_RANGE_300mA:
            valWork = (double)newValue * AMPERE_CONV_FACTOR_4 / 1024.0;
            break;
        case AMPERE_RANGE_1A:
            valWork = (double)newValue * AMPERE_CONV_FACTOR_5 / 1024.0;
            break;
        case AMPERE_RANGE_3A:
            valWork = (double)newValue * AMPERE_CONV_FACTOR_6 / 1024.0;
            break;
        }
        amperesTotal += valWork;
        channel = ADC_CHANNEL_VOLT;
        break;
    }
    return channel;
}

void GetDecimaVal(unsigned int val)
{
    decimalWork[1] = val / 10;
    decimalWork[2] = decimalWork[1] / 10;
    decimalWork[3] = decimalWork[2] / 10;
    decimalWork[0] = val - decimalWork[1] * 10;
    decimalWork[1] = decimalWork[1] - decimalWork[2] * 10;
    decimalWork[2] = decimalWork[2] - decimalWork[3] * 10;
//    decimalWork[3] = decimalWork[3] % 10;
} 

void ShowVolt(double val)
{
    val = val * 100.0;
    GetDecimaVal(val);
    stringWork[0] = 'V';
    stringWork[1] = ':';
    stringWork[2] = decimalWork[3] ? decimalWork[3] + 0x30 : ' ';
    stringWork[3] = decimalWork[2] + 0x30;
    stringWork[4] = '.';
    stringWork[5] = decimalWork[1] + 0x30;
    stringWork[6] = decimalWork[0] + 0x30;
    stringWork[7] = 'V';
    stringWork[8] = 0;
    LCD_Print(stringWork);
}

void ShowAmpere(double val)
{
    char amUnit = ' ';
    char decPoint = 0;
    char amOvf = 0;
    stringWork[0] = ampereRange;
    stringWork[1] = ':';
    stringWork[2] = ' ';
    stringWork[7] = 'A';
    stringWork[8] = 0;
    switch(ampereRange)
    {
    case AMPERE_RANGE_10uA:     // 9.99uA
        if(val > (AMPERE_CONV_FACTOR_1 * 1022.0 / 1024.0)) amOvf = 1;
        val += AMPERE_CONV_FACTOR_1 / 1024.0 / 2;
        val *= 100000000.0;
        if(val > 999) amOvf = 2;
        decPoint = 1;
        amUnit = 'u';
        break;
    case AMPERE_RANGE_100uA:    // 99.9uA
        if(val > (AMPERE_CONV_FACTOR_2 * 1022.02 / 1024.0)) amOvf = 1;
        val += AMPERE_CONV_FACTOR_2 / 1024.0 / 2;
        val *= 10000000.0;
        if(val > 999) amOvf = 2;
        decPoint = 2;
        amUnit = 'u';
        break;
    case AMPERE_RANGE_1mA:      // 999uA
        if(val > (AMPERE_CONV_FACTOR_3 * 1022.0 / 1024.0)) amOvf = 1;
        val += AMPERE_CONV_FACTOR_3 / 1024.0 / 2;
        val *= 1000000.0;
        decPoint = 3;
        amUnit = 'u';
        break;
    case AMPERE_RANGE_300mA:     // 299mA
        if(val > (AMPERE_CONV_FACTOR_4 * 1022.0 / 1024.0)) amOvf = 1;
        val += AMPERE_CONV_FACTOR_4 / 1024.0 / 2;
        val *= 1000.0;
        decPoint = 3;
        amUnit = 'm';
        break;
    case AMPERE_RANGE_1A:    // 999mA
        if(val > (AMPERE_CONV_FACTOR_5 * 1022.0 / 1024.0)) amOvf = 1;
        val += AMPERE_CONV_FACTOR_5 / 1024.0 / 2;
        val *= 1000.0;
        decPoint = 3;
        amUnit = 'm';
        break;
    case AMPERE_RANGE_3A:       // 2.99 A
        if(val > (AMPERE_CONV_FACTOR_6 * 1022.0 / 1024.0)) amOvf = 1;
        val += AMPERE_CONV_FACTOR_6 / 1024.0 / 2;
        val *= 100.0;
        decPoint = 1;
        amUnit = ' ';
        break;
    }
    if(amOvf) {
        stringWork[3] = 'O';
        stringWork[4] = 'V';
        stringWork[5] = 'E';
        stringWork[6] = 'R';
        stringWork[7] = (amOvf == 1)? ' ' : '+';
    } else {
        GetDecimaVal(val);
        stringWork[2] = decimalWork[3] + 0x30;
        stringWork[3] = decimalWork[2] + 0x30;
        stringWork[4] = decimalWork[1] + 0x30;
        stringWork[5] = decimalWork[0] + 0x30;
        if(decPoint == 0) {
            stringWork[2] = '.';
        } else if(decPoint == 3) {
            if(stringWork[2] == 0x30) {
                stringWork[2] = ' ';
                if(stringWork[3] == 0x30) {
                    stringWork[3] = ' ';
                    if(stringWork[4] == 0x30) {
                        stringWork[4] = ' ';
                    }
                }
            }
        } else { // 1 or 2
            stringWork[2] = stringWork[3];
            if(decPoint == 1) {
                stringWork[3] = '.';
            } else {
                if(stringWork[2] == 0x30) stringWork[2] = ' ';
                stringWork[3] = stringWork[4];
                stringWork[4] = '.';
            }
        } 
        stringWork[6] = amUnit;
    }
    LCD_Print(stringWork);
}

int main()
{
	adcChannelIndex = ADC_CHANNEL_VOLT;
    timerCounter = 0;
	LCD_Init();
    LCD_Print("Welcome.");
    _delay_ms(1000);

    voltageTotal = 0.0;
    amperesTotal = 0.0;

    SET_COMPA_REG(12500); // 12.5mS
    SET_TCCR_A;
    SET_TCCR_B;
	ADCSRA = _BV(ADEN) | _BV(ADPS1) | _BV(ADPS0); // 8uS/125KHz

	while(1)
	{
        if(COUNTER_COMPARE_MATCH) {
            CLEAR_FLAG_COMPARE_MATCH;
            if(timerCounter++ < AVERAGE_SIZE) {
	            ADMUX = adcChannelIndex;
            	ADCSRA |= _BV(ADSC); // Start ADC
            } else {
                timerCounter = 0;
                voltageAvrage = voltageTotal / AVERAGE_SIZE;
                voltageTotal = 0;
                LCD_SetPosition(0, 0);
                ShowVolt(voltageAvrage);
                amperesAvrage = amperesTotal / AVERAGE_SIZE;
                amperesTotal = 0;
                LCD_SetPosition(1, 0);
                ShowAmpere(amperesAvrage);
            }
        }

        if(ADCSRA & _BV(ADIF)) {
            ADCSRA |= _BV(ADIF);
            if((adcChannelIndex = GetAdcValue(timerCounter, adcChannelIndex)) != 1)
            {
                ADMUX = adcChannelIndex;
                ADCSRA |= _BV(ADSC); // Start ADC
            }
        }
	}
}
